/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(SERVICE_WORKER)

#include "JSDOMWrapper.h"
#include "ServiceWorkerInternals.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class WEBCORE_TESTSUPPORT_EXPORT JSServiceWorkerInternals : public JSDOMWrapper<ServiceWorkerInternals> {
public:
    using Base = JSDOMWrapper<ServiceWorkerInternals>;
    static JSServiceWorkerInternals* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<ServiceWorkerInternals>&& impl)
    {
        JSServiceWorkerInternals* ptr = new (NotNull, JSC::allocateCell<JSServiceWorkerInternals>(globalObject->vm().heap)) JSServiceWorkerInternals(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static ServiceWorkerInternals* toWrapped(JSC::VM&, JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
protected:
    JSServiceWorkerInternals(JSC::Structure*, JSDOMGlobalObject&, Ref<ServiceWorkerInternals>&&);

    void finishCreation(JSC::VM&);
};

class JSServiceWorkerInternalsOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&, const char**);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, ServiceWorkerInternals*)
{
    static NeverDestroyed<JSServiceWorkerInternalsOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(ServiceWorkerInternals* wrappableObject)
{
    return wrappableObject;
}

WEBCORE_TESTSUPPORT_EXPORT JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, ServiceWorkerInternals&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, ServiceWorkerInternals* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<ServiceWorkerInternals>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<ServiceWorkerInternals>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<ServiceWorkerInternals> {
    using WrapperClass = JSServiceWorkerInternals;
    using ToWrappedReturnType = ServiceWorkerInternals*;
};

} // namespace WebCore

#endif // ENABLE(SERVICE_WORKER)
